<template>
  <a-modal
    :title="title"
    :width="800"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭"
  >
    <a-spin :spinning="confirmLoading">
      <a-form :form="form">
        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          v-if="imageLocalUrl"
          label="图片保存本地地址"
        >
          <a-input placeholder="请输入图片保存本地地址" v-decorator="['localUrl', {}]" />
        </a-form-item>

        <!-- 图片预览 -->
        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          label="图片预览"
          v-if="imagePreviewItem"
        >
          <img style="width:200px;" :src="imagePreviewUrl" />
        </a-form-item>
        <!-- 图片预览 E -->

        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          label="图片名称"
          v-if="imageNameItem"
        >
          <a-input placeholder="请输入图片名称" v-decorator="['imageName', {}]" />
        </a-form-item>
        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" v-if="loginIdItem" label="登录人id">
          <a-input placeholder="请输入登录人id" v-decorator="['loginId', {}]" />
        </a-form-item>
        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          v-if="imageTypeItem"
          label="图片类型 1-竖版图片 2-横版图片"
        >
          <a-input placeholder="请输入图片类型 1-竖版图片 2-横版图片" v-decorator="['materialType', {}]" />
        </a-form-item>
      </a-form>
    </a-spin>
  </a-modal>
</template>

<script>
import { httpAction } from '@/api/manage'
import pick from 'lodash.pick'
import moment from 'moment'

export default {
  name: 'KuaiShouImageModal',
  data() {
    return {
      title: '操作',
      visible: false,
      model: {},
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 }
      },

      confirmLoading: false,
      form: this.$form.createForm(this),
      validatorRules: {},
      url: {
        add: '/kuaishou/kuaiShouImage/add',
        edit: '/kuaishou/kuaiShouImage/edit'
      },
      imageNameItem: true,
      imagePreviewUrl: '',
      loginIdItem: true,
      imageTypeItem: true,
      imagePreviewItem: true,
      imageLocalUrl: true
    }
  },
  created() {},
  mounted() {},
  methods: {
    // 新增
    add() {
      this.edit({})
      this.loginIdItem = true
      this.imageTypeItem = true
      this.imagePreviewItem = false
      this.imageLocalUrl = true
    },
    //   编辑
    edit(record, sign) {
    //   if (sign == 'preview') {
    //     this.imageNameItem = false
    //   }
      this.loginIdItem = false
      this.imageTypeItem = false
      this.imagePreviewItem = true
      this.imageLocalUrl = false
      this.form.resetFields()
      this.model = Object.assign({}, record)
      this.visible = true

      this.$nextTick(() => {
        this.form.setFieldsValue(pick(this.model, 'localUrl', 'imageName', 'imageType', 'loginId', 'materialType'))
      })
      this.imagePreviewUrl = record.localUrl;
    },
    close() {
      this.$emit('close')
      this.visible = false
    },
    handleOk() {
      const that = this
      // 触发表单验证
      this.form.validateFields((err, values) => {
        if (!err) {
          that.confirmLoading = true
          let httpurl = ''
          let method = ''
          if (!this.model.id) {
            httpurl += this.url.add
            method = 'post'
          } else {
            httpurl += this.url.edit
            method = 'put'
          }
          let formData = Object.assign(this.model, values)
          //时间格式化

          console.log(formData)
          httpAction(httpurl, formData, method)
            .then(res => {
              if (res.success) {
                that.$message.success(res.message)
                that.$emit('ok')
              } else {
                that.$message.warning(res.message)
              }
            })
            .finally(() => {
              that.confirmLoading = false
              that.close()
            })
        }
      })
    },
    handleCancel() {
      this.close()
    }
  }
}
</script>

<style lang="less" scoped>
</style>